unit NavBarMask;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls;

type
  TfrmNavBarMask = class(TForm)
    txtMask: TEdit;
    Label1: TLabel;
    btnF: TButton;
    btnE: TButton;
    btnP: TButton;
    btnD: TButton;
    btnOk: TBitBtn;
    btnCancel: TBitBtn;
    Bevel1: TBevel;
    lblTest: TLabel;
    btnTest: TButton;
    procedure btnFClick(Sender: TObject);
    procedure btnEClick(Sender: TObject);
    procedure btnPClick(Sender: TObject);
    procedure btnDClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnTestClick(Sender: TObject);
  private
    fposition:integer;
    procedure Test;
    procedure InsertValue(Value:string);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmNavBarMask: TfrmNavBarMask;

implementation

{$R *.dfm}
procedure TfrmNavBarMask.InsertValue(Value:string);
begin
   fposition:=txtmask.SelStart+3;
   txtmask.Text:=copy(txtmask.Text,1,txtmask.SelStart)+value+
                 copy(txtmask.Text,txtmask.SelStart+txtmask.SelLength+1,length(txtmask.Text)+3);
end;
procedure TfrmNavBarMask.btnFClick(Sender: TObject);
begin
   InsertValue('%f%');
   Test;

end;

procedure TfrmNavBarMask.btnEClick(Sender: TObject);
begin
   InsertValue('%e%');
   Test;
end;

procedure TfrmNavBarMask.btnPClick(Sender: TObject);
begin
   InsertValue('%p%');
   Test;
end;

procedure TfrmNavBarMask.btnDClick(Sender: TObject);
begin
   InsertValue('%d%');
   Test;
end;

procedure TfrmNavBarMask.Test;
var
   t:string;
begin
   t:=txtMask.Text;
   t:=stringreplace(t,'%d%','34',[rfReplaceAll,rfIgnoreCase]);
   t:=stringreplace(t,'%p%','12',[rfReplaceAll,rfIgnoreCase]);
   t:=stringreplace(t,'%f%','1',[rfReplaceAll,rfIgnoreCase]);
   t:=stringreplace(t,'%e%','34',[rfReplaceAll,rfIgnoreCase]);
   lblTest.Caption:=t;
   txtmask.SelStart:=fposition;
   txtmask.SetFocus;
end;

procedure TfrmNavBarMask.FormActivate(Sender: TObject);
begin
   Test;
end;

procedure TfrmNavBarMask.btnTestClick(Sender: TObject);
begin
   Test;
end;

end.
