{$IFNDEF VER90} //If not D2
  {$DEFINE D3_OR_hIGHER}
  {$IFNDEF VER100} //If not D3
    {$DEFINE D4_OR_HIGHER}
    {$IFNDEF VER120} //If not D4
      {DEFINE D5_OR_HIGHER}        //2.4
      {$IFNDEF VER130} //If not D5 //2.4
        {$DEFINE D6_OR_HIGHER}
      {$ENDIF}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}
unit RegEditorSelPanel;
interface
uses
   classes, graphics,
{$IFDEF D6_OR_HIGHER}
   DesignIntf, DesignEditors   //2.4
{$ELSE}
   DsgnIntf
{$ENDIF};
type
  TSelPanelEditor=Class(TComponentEditor)
     public
        procedure ExecuteVerb(Index:Integer);override;
        Function GetVerb(Index:Integer):string;override;
        function GetVerbCount:Integer;override;
  end;

procedure Register;
implementation
uses
   SelPanel;
procedure TSelPanelEditor.ExecuteVerb(Index:Integer);
begin
   with TSelPanel(Component) do
   case Index of
      0:begin
           Colors[0]:=$0035D1FF;
           Colors[1]:=$000089B0;
           Colors[2]:=$000089B0;
           Colors[3]:=$009AF1F5;
           Colors[4]:=$0009699D;
           Colors[5]:=$0009699D;
           Colors[6]:=$002894FF;
           Colors[7]:=$00004182;
           Colors[8]:=$00004182;
        end;
      1:begin
           Colors[0]:=$00ADD1AD;
           Colors[1]:=$003D6D3D;
           Colors[2]:=$003D6D3D;
           Colors[3]:=$0040FF40;
           Colors[4]:=$0016813F;
           Colors[5]:=$0016813F;
           Colors[6]:=$00B3F4DF;
           Colors[7]:=$000D8A58;
           Colors[8]:=$000D8A58;
        end;
      2:Begin
           Colors[0]:=$00EEC49D;
           Colors[1]:=$0091521A;
           Colors[2]:=$0091521A;
           Colors[3]:=$00FFCACA;
           Colors[4]:=$00AE0000;
           Colors[5]:=$00AE0000;
           Colors[6]:=$00FF5E5E;
           Colors[7]:=$009B0000;
           Colors[8]:=$009B0000;
        end;
      3:Begin
           Colors[0]:=$008888E3;
           Colors[1]:=$00202086;
           Colors[2]:=$00202086;
           Colors[3]:=$00C8C8FD;
           Colors[4]:=$000000AE;
           Colors[5]:=$000000AE;
           Colors[6]:=$005151FF;
           Colors[7]:=$0000008C;
           Colors[8]:=$0000008C;
        end;
      4:Begin
           Colors[0]:=$003EB5F4;
           Colors[1]:=$0009699D;
           Colors[2]:=$0009699D;
           Colors[3]:=$00C7E8FE;
           Colors[4]:=$000262A2;
           Colors[5]:=$000262A2;
           Colors[6]:=$00A3A3D1;
           Colors[7]:=$004D4D99;
           Colors[8]:=$004D4D99;
        end;
   end;
   Designer.Modified;
end;
function TSelPanelEditor.GetVerb(Index:Integer):string;
begin
   case Index of
      0:Result:='i-griegavcl';
      1:Result:='Green';
      2:Result:='Blue';
      3:Result:='Red';
      4:Result:='Maroon';
   end;
end;
function TSelPanelEditor.GetVerbCount:integer;
begin
   result:=5;
end;
procedure Register;
begin
  RegisterComponentEditor(TSelPanel,TSelPanelEditor);
end;
end.

