{$IFNDEF VER90} //If not D2
  {$DEFINE D3_OR_hIGHER}
  {$IFNDEF VER100} //If not D3
    {$DEFINE D4_OR_HIGHER}
    {$IFNDEF VER120} //If not D4
      {DEFINE D5_OR_HIGHER}        //2.4
      {$IFNDEF VER130} //If not D5 //2.4
        {$DEFINE D6_OR_HIGHER}
      {$ENDIF}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}
unit RegEditorVisuProp;
interface
uses
   classes,
{$IFDEF D6_OR_HIGHER}
   DesignIntf, DesignEditors   //2.4
{$ELSE}
   DsgnIntf
{$ENDIF};
type
  TVisuEditor=Class(TComponentEditor)
     public
        procedure ExecuteVerb(Index:Integer);override;
        Function GetVerb(Index:Integer):string;override;
        function GetVerbCount:Integer;override;
  end;

procedure Register;
implementation
uses
   VisualProp,Dialogs;
procedure TVisuEditor.ExecuteVerb(Index:Integer);
var
   F:TSaveDialog;
begin
   case Index of
      0:TVisualprop(Component).Perform;
      1:begin
           f:=Tsavedialog.Create(nil);
           if f.Execute then
              TVisualprop(Component).SaveToFile(f.FileName);
           f.Free;
        end;
   end;
end;
function TVisuEditor.GetVerb(Index:Integer):string;
begin
   case Index of
      0:Result:='Perform';
      1:Result:='Save properties to ...';
   end;
end;
function TVisuEditor.GetVerbCount:integer;
begin
   result:=2;
end;
procedure Register;
begin
  RegisterComponents('i-vcl Non-Visual', [TVisualprop]);
  RegisterComponentEditor(TVisualProp,TVisuEditor);
end;
end.
 