{$IFNDEF VER90} //If not D2
  {$DEFINE D3_OR_hIGHER}
  {$IFNDEF VER100} //If not D3
    {$DEFINE D4_OR_HIGHER}
    {$IFNDEF VER120} //If not D4
      {DEFINE D5_OR_HIGHER}        //2.4
      {$IFNDEF VER130} //If not D5 //2.4
        {$DEFINE D6_OR_HIGHER}
      {$ENDIF}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}
unit RegEditorhotspotmapN;
interface
uses
   classes,
{$IFDEF D6_OR_HIGHER}
   DesignIntf, DesignEditors   //2.4
{$ELSE}
   DsgnIntf
{$ENDIF},sysutils,controls;
type
  THotSpotEditorN=Class(TComponentEditor)
     public
        procedure ExecuteVerb(Index:Integer);override;
        Function GetVerb(Index:Integer):string;override;
        function GetVerbCount:Integer;override;
  end;
procedure Register;
implementation
uses
   hotspotmapN,Dialogs;
procedure THotSpotEditorN.ExecuteVerb(Index:Integer);
//---------------
procedure SetLoadFrom;
var
   PolList:TStringList;
   i:integer;
   b:boolean;
   OFD:TOpenDialog;
   counter:Integer;
begin
   counter:=0;
   OFD:=TOpenDialog.Create(nil);
   OFD.Filter:='Poligons (*.plg)|*.plg|All (*.*)|*.*';
   OFD.DefaultExt:='plg';
   OFD.Title:='Abrir fichero de polgonos';
   if OFD.execute then
   begin
   b:=false;
   if THotSpotMapN(Component).Polygons.Count>0 then
   begin
     if  messagedlg('Ya existen polgonos. Desea cargarlos desde el fichero?',mtConfirmation, [mbYes, mbNo], 0) = mrYes then
        b:=true;
   end
   else
      b:=true;
   if b then
   with THotSpotMapN(Component).Polygons do
   begin
      Clear;
      pollist:=tstringList.Create;
      pollist.LoadFromFile(OFD.FileName);
      for i:=0 to pollist.Count-1 do
        begin
           pollist.Strings[i]:=uppercase(trim(Stringreplace(pollist.Strings[i],chr(9),' ',[rfReplaceAll])));
           if system.copy(pollist.Strings[i],1,8)='POLYGON ' then
           begin
              Add;
              counter:=counter+1;
           end;
           if (system.copy(pollist.Strings[i],1,6)='POINT ') and (Count>0) then
              Items[Count-1].Poly.add;
           if (system.copy(pollist.Strings[i],1,2)='X=') and (Count>0) then
              if Items[Count-1].Poly.count>0 then
                 Items[Count-1].Poly[Items[Count-1].Poly.count-1].Point.X:=strtoint(system.copy(pollist.Strings[i],3,10));
           if (system.copy(pollist.Strings[i],1,2)='Y=') and (Count>0) then
              if Items[Count-1].Poly.count>0 then
                 Items[Count-1].Poly[Items[Count-1].Poly.count-1].Point.Y:=strtoint(system.copy(pollist.Strings[i],3,10));
        end;
        pollist.Free;
        showmessage(inttostr(Counter)+' polgonos aadidos');
      end;
      end;
      OFD.Free;
end;

/////
begin
   case Index of
      0:SetLoadFrom; //THotSpotEditor(Component).Perform;
   end;
end;
function THotSpotEditorN.GetVerb(Index:Integer):string;
begin
   case Index of
      0:Result:='Load From ...';
   end;
end;
function THotSpotEditorN.GetVerbCount:integer;
begin
   result:=1;
end;
procedure Register;
begin
  RegisterComponents('i-griegavcl', [THotSpotMapN]);
  RegisterComponentEditor(THotSpotMapN,THotSpotEditorN);
end;
end.
