{$IFNDEF VER90} //If not D2
  {$DEFINE D3_OR_hIGHER}
  {$IFNDEF VER100} //If not D3
    {$DEFINE D4_OR_HIGHER}
    {$IFNDEF VER120} //If not D4
      {DEFINE D5_OR_HIGHER}        //2.4
      {$IFNDEF VER130} //If not D5 //2.4
        {$DEFINE D6_OR_HIGHER}
      {$ENDIF}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}
unit funciones;

interface
uses
  Db,
  DBTables,windows,
  ComObj,Graphics,forms,controls,
  Messages,Dialogs,sysutils,classes;
type
TOnNewRecordBeforeExport = procedure(Sender : TObject; dataset:tdataset;var Cancel:boolean) of object;
TOnExportFieldEvent = procedure(Sender : TObject; FieldName:string; var Fielddata:variant; var cancel:boolean) of object;
TOnExportFieldFormatEvent = procedure(Sender : TObject; FieldName:string; var Fielddata:variant; var Format:string; var cancel:boolean) of object;
TDecodeString = array[1..2]of array of string;
var
   dirhtml:string;
   fichHtml:string;
   basepath:string;
   datefilehtml:integer;
function Decode(cond:string;valores:TDecodeString;ifnoexist:string):string;
function Iif(cond:boolean;ctrue:string;cfalse:string):string; overload;
function Iif(cond:boolean;ctrue:integer;cfalse:integer):integer; overload;
function Iif(cond:boolean;ctrue:double;cfalse:double):double; overload;
function Iif(cond:boolean;ctrue:boolean;cfalse:boolean):boolean; overload;
function ColorToHtml(DColor:TColor):string;
function ComponentToString(Component: TComponent): string;
procedure StringToComponent(Component: TComponent;Value: string);
Procedure SaveComponent(Component: TComponent;filename:tfilename);
Procedure LoadComponent(Component:TComponent;filename:tfilename);
Function FileTemp(prefix:string):string;
{function SelectDirectoryA(const Caption: string; const Root: WideString;const InitDir:WideString;
  out Directory: string): Boolean;}

implementation
uses ShlObj,ActiveX ;
Function FileTemp(prefix:string):string;
begin
   SetLength(result, MAX_PATH + 1);
   gettempfilename('c:\windows\temp',pchar(prefix),0,pchar(result));
end;
function Decode(cond:string;valores:TDecodeString;ifnoexist:string):string;
var i:integer;
begin
   for I:=low(valores) to high(valores) do
      if valores[i,1]=cond then
      begin
         result:=valores[i,2];
         break;
      end;
end;
{function SelectDirectoryA(const Caption: string; const Root: WideString;const InitDir:WideString;
  out Directory: string): Boolean;
var
  WindowList: Pointer;
  BrowseInfo: TBrowseInfo;
  RootItemIDList, ItemIDList: PItemIDList;
  ShellMalloc: IMalloc;
  IDesktopFolder: IShellFolder;
  Eaten, Flags: LongWord;
  Buffer: PChar;
begin
  Result := False;
  Directory := '';
  FillChar(BrowseInfo, SizeOf(BrowseInfo), 0);
  if (ShGetMalloc(ShellMalloc) = S_OK) and (ShellMalloc <> nil) then
  begin
    Buffer := ShellMalloc.Alloc(MAX_PATH);
    buffer:=pchar(initdir);
    try
      RootItemIDList := nil;
      if Root <> '' then
      begin
        SHGetDesktopFolder(IDesktopFolder);
        IDesktopFolder.ParseDisplayName(Application.Handle, nil,
          POleStr(Root), Eaten, RootItemIDList, Flags);
      end;
      with BrowseInfo do
      begin
        hwndOwner := Application.Handle;
        pidlRoot := RootItemIDList;
        pszDisplayName := buffer;
        lpszTitle := PChar(Caption);
        ulFlags := BIF_RETURNONLYFSDIRS;
      end;
      WindowList := DisableTaskWindows(0);
      try
        ItemIDList := ShBrowseForFolder(BrowseInfo);
      finally
        EnableTaskWindows(WindowList);
      end;
      Result :=  ItemIDList <> nil;
      if Result then
      begin
        ShGetPathFromIDList(ItemIDList, Buffer);
        ShellMalloc.Free(ItemIDList);
        Directory := Buffer;
      end;
    finally
      ShellMalloc.Free(Buffer);
    end;
  end;
end;}
Procedure SaveComponent(Component: TComponent;filename:tfilename);
var
   S:tstringlist;
begin
   s:=tstringlist.Create;
   s.Add(ComponentToString(Component));
   s.SaveToFile(filename);
   s.Free
end;
Procedure LoadComponent(Component:TComponent;filename:tfilename);
var
   S:tstringlist;
   i:integer;
   cad:string;
begin
   cad:='';
   s:=tstringlist.Create;
   s.LoadFromFile(filename);
   s.Insert(1,'object '+component.Name+': '+component.ClassName);
   for i:=1 to s.Count-1 do
      cad:=cad+s.Strings[i]+#10;
   try
      StringToComponent(component,cad);
   finally
      s.Free
   end;
end;
function ComponentToString(Component: TComponent): string;

var
  BinStream:TMemoryStream;
  StrStream: TStringStream;
  s: string;
begin
  BinStream := TMemoryStream.Create;
  try
    StrStream := TStringStream.Create(s);
    try
      BinStream.WriteComponent(Component);
      BinStream.Seek(0, soFromBeginning);
      ObjectBinaryToText(BinStream, StrStream);
      StrStream.Seek(0, soFromBeginning);
      Result:= StrStream.DataString;
//      binstream.SaveToFile(filename);
    finally
      StrStream.Free;

    end;
  finally
    BinStream.Free
  end;
end;

procedure StringToComponent(Component: TComponent;Value: string);
var
  StrStream:TStringStream;
  BinStream: TMemoryStream;
begin
  StrStream := TStringStream.Create(Value);
  try
    BinStream := TMemoryStream.Create;
    try
      ObjectTextToBinary(StrStream, BinStream);
      BinStream.Seek(0, soFromBeginning);
      BinStream.ReadComponent(component);
    finally
      BinStream.Free;
    end;
  finally
    StrStream.Free;
  end;
end;
function ColorToHtml(DColor:TColor):string;
 var
   tmpRGB : Tcolor;
begin
   tmpRGB := ColorToRGB(DColor);
   Result:=Format('#%.2x%.2x%.2x',
                  [GetRValue(tmpRGB),
                   GetGValue(tmpRGB),
                   GetBValue(tmpRGB)]);
end; {function ColorToHtml}

function Iif(cond:boolean;ctrue:string;cfalse:string):string;
begin
   if cond then result:=ctrue else result:=cfalse;
end;
function Iif(cond:boolean;ctrue:integer;cfalse:integer):integer;
begin
   if cond then result:=ctrue else result:=cfalse;
end;
function Iif(cond:boolean;ctrue:double;cfalse:double):double;
begin
   if cond then result:=ctrue else result:=cfalse;
end;
function Iif(cond:boolean;ctrue:boolean;cfalse:boolean):boolean;
begin
   if cond then result:=ctrue else result:=cfalse;
end;

end.
