unit logviewer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ComCtrls;

type
  TfrmViewer = class(TForm)
    Memo: TRichEdit;
    PopupMenu1: TPopupMenu;
    Limpiar1: TMenuItem;
    SD: TSaveDialog;
    GuardarComo1: TMenuItem;
    Guardartextoplanocomo1: TMenuItem;
    procedure Limpiar1Click(Sender: TObject);
    procedure GuardarComo1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Guardartextoplanocomo1Click(Sender: TObject);
  private
    { Private declarations }
  public
    FCerrar:Boolean;
    { Public declarations }
  end;

var
  frmViewer: TfrmViewer;

implementation

{$R *.dfm}

procedure TfrmViewer.Limpiar1Click(Sender: TObject);
begin
   memo.Clear;
end;

procedure TfrmViewer.GuardarComo1Click(Sender: TObject);
begin
   if sd.Execute then
      memo.Lines.SaveToFile(sd.FileName);
end;

procedure TfrmViewer.FormCreate(Sender: TObject);
begin
  sd.InitialDir:=getcurrentdir;
  FCerrar:=False;
end;

procedure TfrmViewer.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   if not FCerrar then canclose:=false;
end;

procedure TfrmViewer.Guardartextoplanocomo1Click(Sender: TObject);
var
   Memotmp:TStringlist;
begin
   Memotmp:=tStringlist.Create;
   memotmp.AddStrings(memo.Lines);
   if sd.Execute then
      memotmp.SaveToFile(sd.FileName);
   memotmp.Free;
end;

end.
