unit BrowseOpenDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  propShell;

type
  TBrowseOpenDialog = class(TComponent)
  private
     FInitialDir:string;
     FOutDir:string;
     FRootFolder:TRootFolder;
     FTitle:string;
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    Function Execute:Boolean;
    constructor Create(AWoner:TComponent); override;
  published
     property Title:string read FTitle Write FTitle;
     property InitialDir:string read FInitialDir write FInitialDir;
     property OutDir:string read FOutDir;
     Property RootFolder:TRootFolder read FRootFolder write FRootFolder;
    { Published declarations }
  end;

implementation
constructor TBrowseOpenDialog.Create(AWoner:TComponent);
begin
   inherited;
   RootFolder:=rtDrives;
end;

Function TBrowseOpenDialog.Execute:Boolean;
begin
   FOutDir:=browseFolderDialog(title,RootFolder,InitialDir);
   if OutDir='' then result:=false else result:=true;
end;
end.
