unit ButtonOver;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls;

type
  TButtonOver = class(TButton)
  private
       FOnMouseLeave: TNotifyEvent;
       FOnMouseEnter: TNotifyEvent;
       procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
       procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
       property OnMouseEnter: TNotifyEvent read FOnMouseEnter write FOnMouseEnter;
       property OnMouseLeave: TNotifyEvent read FOnMouseLeave write FOnMouseLeave;
  end;

procedure Register;

implementation

procedure TButtonOver.CMMouseEnter(var Message: TMessage);
begin
  inherited;
  if Assigned(FOnMouseEnter) then
    FOnMouseEnter(Self);
end;

procedure TButtonOver.CMMouseLeave(var Message: TMessage);
begin
  inherited;
  if Assigned(FOnMouseLeave) then
    FOnMouseLeave(Self);
end;


procedure Register;
begin
  RegisterComponents('i-griegavcl', [TButtonOver]);
end;

end.
