unit GraphCheckBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls,graphics;

type
  TGraphCheckBox = class(TCustomCheckBox)
  private
    FCanvas: TCanvas;
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
  protected
    procedure Paint;
    property Canvas: TCanvas read FCanvas;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    Property Caption;
    { Published declarations }
  end;

procedure Register;

implementation
constructor TGraphCheckBox.Create(Aowner:TComponent);
begin
  inherited Create(AOwner);
  FCanvas := TControlCanvas.Create;
  TControlCanvas(FCanvas).Control := Self;
end;
destructor TGraphCheckBox.Destroy;
begin
  FCanvas.Free;
  inherited Destroy;
end;
procedure TGraphCheckBox.WMPaint(var Message: TWMPaint);
begin
if Message.DC <> 0 then
  begin
    Canvas.Lock;
    try
      Canvas.Handle := Message.DC;
      try
        Paint;
      finally
        Canvas.Handle := 0;
      end;
    finally
      Canvas.Unlock;
    end;
  end;
end;

procedure TGraphCheckBox.Paint;
begin
   fcanvas.TextOut(0,0,'Pedro');
end;

procedure Register;
begin
  RegisterComponents('i-griegavcl', [TGraphCheckBox]);
end;

end.
