unit HTMLParam;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus, Label3D, funciones,  Buttons, OleCtrls,
  SHDocVw;

type
  THTMLParam = class(TForm)
    cd1: TColorDialog;
    menu: TPopupMenu;
    Texto1: TMenuItem;
    Fondo1: TMenuItem;
    Panel1: TPanel;
    Label3D1: TLabel3D;
    Label3D2: TLabel3D;
    txttitle: TLabel;
    txtSubtitle: TLabel;
    pBarTitle: TPanel;
    PText: TPanel;
    Panel2: TPanel;
    Label3D3: TLabel3D;
    Bevel1: TBevel;
    PbgTable: TPanel;
    PD1: TPanel;
    PD2: TPanel;
    Label3D4: TLabel3D;
    Label3D5: TLabel3D;
    ChkDifferent: TCheckBox;
    Label3D6: TLabel3D;
    txtNombreTabla: TEdit;
    txtBorder: TEdit;
    Label3D7: TLabel3D;
    pBorder: TPanel;
    Label3D8: TLabel3D;
    txtpadding: TEdit;
    Label3D9: TLabel3D;
    txtspacing: TEdit;
    Bevel2: TBevel;
    Label3D10: TLabel3D;
    btnAceptar: TBitBtn;
    btnCancelar: TBitBtn;
    WB1: TWebBrowser;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    Label3D11: TLabel3D;
    chk_css: TCheckBox;
    txt_css: TEdit;
    OD: TOpenDialog;
    Button1: TButton;
    procedure Texto1Click(Sender: TObject);
    procedure Fondo1Click(Sender: TObject);
    procedure txttitleClick(Sender: TObject);
    procedure txtSubtitleClick(Sender: TObject);
    procedure pBarTitleMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PTextMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PbgTableClick(Sender: TObject);
    procedure PD1Click(Sender: TObject);
    procedure PD2Click(Sender: TObject);
    procedure pBorderClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure ChkDifferentClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure chk_cssClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  f:string;
//  frmHTMLParam: TfrmHTMLParam;

implementation

{$R *.DFM}

procedure THTMLParam.Texto1Click(Sender: TObject);
begin
   cd1.Color:=tpanel(menu.PopupComponent).Font.Color;
   if cd1.execute then
      tpanel(menu.PopupComponent).font.Color:=cd1.Color;
end;

procedure THTMLParam.Fondo1Click(Sender: TObject);
begin
   cd1.Color:=tpanel(menu.PopupComponent).Color;
   if cd1.execute then
   begin
      tpanel(menu.PopupComponent).Color:=cd1.Color;
      if not chkdifferent.Checked then
      begin
         PD1.Font.Color:=cd1.Color;
         PD2.font.Color:=cd1.Color;
      end;
   end;

end;

procedure THTMLParam.txttitleClick(Sender: TObject);
begin
   cd1.Color:=txtTitle.Font.Color;
   if cd1.execute then
      txtTitle.font.Color:=cd1.Color;
end;

procedure THTMLParam.txtSubtitleClick(Sender: TObject);
begin
   cd1.Color:=txtSubTitle.Font.Color;
   if cd1.execute then
      txtSubTitle.font.Color:=cd1.Color;

end;

procedure THTMLParam.pBarTitleMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 menu.PopupComponent:=pBarTitle;
 Menu.Popup(mouse.CursorPos.x, mouse.CursorPos.y);
end;

procedure THTMLParam.PTextMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 menu.PopupComponent:=PText;
 Menu.Popup(mouse.CursorPos.x, mouse.CursorPos.y);
end;

procedure THTMLParam.PbgTableClick(Sender: TObject);
begin
   cd1.Color:=PbgTable.Color;
   if cd1.execute then
   begin
      PbgTable.Color:=cd1.Color;
   end;
end;

procedure THTMLParam.PD1Click(Sender: TObject);
begin
   cd1.Color:=PD1.Font.Color;
   if cd1.execute then
      PD1.Font.Color:=cd1.Color;
end;

procedure THTMLParam.PD2Click(Sender: TObject);
begin
   cd1.Color:=PD2.Font.Color;
   if cd1.execute then
      PD2.Font.Color:=cd1.Color;
end;

procedure THTMLParam.pBorderClick(Sender: TObject);
begin
   cd1.Color:=pBorder.Color;
   if cd1.execute then
      pBorder.Color:=cd1.Color;
end;

procedure THTMLParam.BitBtn1Click(Sender: TObject);
begin
if f<>'' then
   deletefile(f);
memo1.Lines.Clear;
if txt_css.text='' then
begin
   memo1.Lines.Add('<!doctype html public "-//w3c//dtd html 4.0 transitional//en">');
   memo1.Lines.Add('<html>');
   memo1.Lines.Add('<head>');
   memo1.Lines.Add('   <meta name="Author" content="">');
   memo1.Lines.Add('   <meta name="GENERATOR" content="Mozilla/4.51 [es]">');
   memo1.Lines.Add('</head>');
   memo1.Lines.Add('<CENTER>');
   memo1.Lines.Add('<H1><FONT color="'+colortohtml(txtTitle.font.Color)+'">Ttulo</FONT></H1>');
   memo1.Lines.Add('<H2><FONT color="'+colortohtml(txtSubTitle.Font.Color)+'">SubTtulo</FONT></H2>');
   memo1.Lines.Add('<TABLE name="tabla" '+iif(txtspacing.Text<>'','cellspacing="'+txtspacing.text+'" ','')+
      iif(txtpadding.Text<>'','cellpadding="'+txtpadding.text+'" ','')+
      iif(txtborder.Text<>'','border="'+txtborder.text+'"','')+
      'bgcolor="'+colortohtml(pbgtable.Color)+'" bordercolor="'+colortohtml(pBorder.Color)+'">');
   memo1.Lines.Add('<TR bgcolor="'+colortohtml(PBarTitle.Color)+'">');
   memo1.Lines.Add('<TD><B>NUMERO</B></TD>');
   memo1.Lines.Add('<TD><B>CONCEPTO</B></TD>');
   memo1.Lines.Add('</TR>');
   memo1.Lines.Add('<TR bgcolor="'+colortohtml(PD1.Color)+'">');
   memo1.Lines.Add('<TD align="right" ><FONT color="'+colortohtml(PD1.Font.Color)+'">2323</FONT></TD>');
   memo1.Lines.Add('<TD><FONT color="'+colortohtml(PD1.Font.Color)+'">Producto 1</FONT></TD>');
   memo1.Lines.Add('</TR>');
   memo1.Lines.Add('<TR bgcolor="'+colortohtml(PD2.Color)+'">');
   memo1.Lines.Add('<TD align="right" ><FONT color="'+colortohtml(PD2.Font.Color)+'">2330</FONT></TD>');
   memo1.Lines.Add('<TD><FONT color="'+colortohtml(PD2.Font.Color)+'">Producto 2</FONT></TD>');
   memo1.Lines.Add('</TR>');
   memo1.Lines.Add('<TR bgcolor="'+colortohtml(PD1.Color)+'">');
   memo1.Lines.Add('<TD align="right" ><FONT color="'+colortohtml(PD1.Font.Color)+'">2340</FONT></TD>');
   memo1.Lines.Add('<TD><FONT color="'+colortohtml(PD1.Font.Color)+'">Producto 3</FONT></TD>');
   memo1.Lines.Add('</TR>');
   memo1.Lines.Add('<TR bgcolor="'+colortohtml(PD2.Color)+'">');
   memo1.Lines.Add('<TD align="right" ><FONT color="'+colortohtml(PD2.Font.Color)+'">2350</FONT></TD>');
   memo1.Lines.Add('<TD><FONT color="'+colortohtml(PD2.Font.Color)+'">Producto 4</FONT></TD>');
   memo1.Lines.Add('</TR>');
   memo1.Lines.Add('</TABLE>');
   memo1.Lines.Add('</CENTER>');
   memo1.Lines.Add('</BODY>');
   memo1.Lines.Add('</HTML>');
end
else
begin
   memo1.Lines.Add('<!doctype html public "-//w3c//dtd html 4.0 transitional//en">');
   memo1.Lines.Add('<html>');
   memo1.Lines.Add('<head>');
   memo1.Lines.Add('   <meta name="Author" content="">');
   memo1.Lines.Add('   <meta name="GENERATOR" content="Mozilla/4.51 [es]">');
   memo1.Lines.Add('   <LINK REL="stylesheet" TYPE="text/css" HREF="'+txt_css.text+'">');
   memo1.Lines.Add('</head>');
   memo1.Lines.Add('<CENTER>');
   memo1.Lines.Add('<H1 class=Title>Ttulo</H1>');
   memo1.Lines.Add('<H2 class=SubTitle>SubTtulo</H2>');
   memo1.Lines.Add('<TABLE name="tabla" class=Table>');
   memo1.Lines.Add('<TR class=HeadTable>');
   memo1.Lines.Add('<TD><B>NUMERO</B></TD>');
   memo1.Lines.Add('<TD><B>CONCEPTO</B></TD>');
   memo1.Lines.Add('</TR>');
   memo1.Lines.Add('<TR class=L1>');
   memo1.Lines.Add('<TD align="right" >2323</TD>');
   memo1.Lines.Add('<TD>Producto 1</TD>');
   memo1.Lines.Add('</TR>');
   memo1.Lines.Add('<TR class=L2>');
   memo1.Lines.Add('<TD align="right" >2330</TD>');
   memo1.Lines.Add('<TD>Producto 2</TD>');
   memo1.Lines.Add('</TR>');
   memo1.Lines.Add('<TR class=L1>');
   memo1.Lines.Add('<TD align="right" >2340</TD>');
   memo1.Lines.Add('<TD>Producto 3</TD>');
   memo1.Lines.Add('</TR>');
   memo1.Lines.Add('<TR class=L2>');
   memo1.Lines.Add('<TD align="right" >2350</TD>');
   memo1.Lines.Add('<TD>Producto 4</TD>');
   memo1.Lines.Add('</TR>');
   memo1.Lines.Add('</TABLE>');
   memo1.Lines.Add('</CENTER>');
   memo1.Lines.Add('</BODY>');
   memo1.Lines.Add('</HTML>');
end;
f:=FileTemp('htm');
memo1.Lines.SaveToFile(f);
wb1.Navigate(f);

end;

procedure THTMLParam.ChkDifferentClick(Sender: TObject);
begin
   if not chkdifferent.Checked then
   begin
      pd1.Color:=clwindow;
      pd2.Color:=clwindow;
      pd1.font.Color:=ptext.Color;
      pd2.font.Color:=ptext.Color;
   end;
end;

procedure THTMLParam.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   if f<>'' then
      deletefile(f);
end;

procedure THTMLParam.chk_cssClick(Sender: TObject);
begin
if not chk_css.Checked then
   txt_css.Text:='';
end;

procedure THTMLParam.Button1Click(Sender: TObject);
begin
   if od.Execute then
      txt_css.Text:=od.FileName;
end;

end.
