{$IFNDEF VER90} //If not D2
  {$DEFINE D3_OR_hIGHER}
  {$IFNDEF VER100} //If not D3
    {$DEFINE D4_OR_HIGHER}
    {$IFNDEF VER120} //If not D4
      {DEFINE D5_OR_HIGHER}        //2.4
      {$IFNDEF VER130} //If not D5 //2.4
        {$DEFINE D6_OR_HIGHER}
      {$ENDIF}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}
unit RegEditorShapeForm;
interface
uses
   classes, graphics,dialogs,igriegastrs,
{$IFDEF D6_OR_HIGHER}
   DesignIntf, DesignEditors   //2.4
{$ELSE}
   DsgnIntf
{$ENDIF};
type
  TShapeFormEditor=Class(TComponentEditor)
     public
        procedure ExecuteVerb(Index:Integer);override;
        Function GetVerb(Index:Integer):string;override;
        function GetVerbCount:Integer;override;
        procedure Edit;override;
  end;

procedure Register;
implementation
uses
   ShapeForm,ShapeFormEd,forms;
procedure TShapeFormEditor.Edit;
var
   F:TfrmPrinShForm;
   BActive:Boolean;
begin
   bactive:=TShapeForm(Component).Active;
   TShapeForm(Component).Active:=false;
   f:=TfrmPrinShForm.Create(Application);
   f.Polygons:=TShapeForm(Component).Polygons;
   f.Showmodal;
//   TShapeForm(Component).Polygons:=TShapePolygon(f.Polygons);
   f.Free;
   TShapeForm(Component).Active:=bActive;
end;
procedure TShapeFormEditor.ExecuteVerb(Index:Integer);
var
   OC:TOpenDialog;
   Sc:TSaveDialog;
begin
   with TShapeForm(Component) do
   case Index of
      0:Edit;
      1:begin
           oc:=topendialog.Create(component);
           oc.DefaultExt:='xml';
           oc.Filter:='XML Polygons Document (*.xml)|*.XML';
           oc.Title:=sMsgTitleShapeFormOpen;
           if oc.Execute then
              TShapeForm(Component).Polygons.LoadFromFile(oc.FileName);
           oc.Free;
        end;
      2:begin
           sc:=tsavedialog.Create(component);
           sc.DefaultExt:='xml';
           sc.Filter:='XML Polygons Document (*.xml)|*.XML';
           sc.Title:=sMsgTitleShapeFormSave;
           if sc.Execute then
              TShapeForm(Component).Polygons.SavetoFile(sc.FileName);
           sc.Free;
        end;
   end;
   Designer.Modified;
end;
function TShapeFormEditor.GetVerb(Index:Integer):string;
begin
   case Index of
      0:result:=sMsgPolShFormEditor;
      1:Result:=sMsgPolLoadFromFile;
      2:Result:=sMsgPolSaveToFile;
   end;
end;
function TShapeFormEditor.GetVerbCount:integer;
begin
   result:=3;
end;
procedure Register;
begin
  RegisterComponentEditor(TShapeForm,TShapeFormEditor);
end;
end.

