{$IFNDEF VER90} //If not D2
  {$DEFINE D3_OR_hIGHER}
  {$IFNDEF VER100} //If not D3
    {$DEFINE D4_OR_HIGHER}
    {$IFNDEF VER120} //If not D4
      {DEFINE D5_OR_HIGHER}        //2.4
      {$IFNDEF VER130} //If not D5 //2.4
        {$DEFINE D6_OR_HIGHER}
      {$ENDIF}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}

unit RegPropertiesHTMLExport;

interface
uses
   classes,
{$IFDEF D6_OR_HIGHER}
   DesignIntf, DesignEditors   //2.4
{$ELSE}
   DsgnIntf
{$ENDIF};
type
TFieldsProperty = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

procedure Register;
implementation
uses
   HTMLExport,FieldsType,funciones,fields,forms,controls;

procedure TFieldsProperty.Edit;
var
  FieldsEditor: TfrmFields ;
  i,index:integer;

begin
  FieldsEditor := TfrmFields.Create(Application);
  try
     if TFieldsType(Getcomponent(0)).fields.Count>0 then
     begin
        fieldseditor.L2.Clear;
        fieldseditor.L1.Clear;
        TFieldsType(Getcomponent(0)).table.FieldDefs.update;
        for i:=0 to TFieldsType(Getcomponent(0)).table.FieldDefs.count -1 do
        begin
           if TFieldsType(Getcomponent(0)).fields.Locate(TFieldsType(Getcomponent(0)).table.FieldDefs[i].Name,index) then
              fieldseditor.L2.Items.Add(TFieldsType(Getcomponent(0)).table.FieldDefs[i].Name)
           else
              fieldseditor.L1.Items.Add(TFieldsType(Getcomponent(0)).table.FieldDefs[i].Name);
        end;
     end
     else
     begin
        TFieldsType(Getcomponent(0)).setallfields;
        fieldseditor.L2.Items.Assign(TFieldsType(Getcomponent(0)).fields);
     end;
     if FieldsEditor.ShowModal=mrok then
     begin
        TFieldsType(Getcomponent(0)).fields.clear;
        TFieldsType(Getcomponent(0)).fields.Assign(fieldseditor.L2.Items);
        designer.Modified;
     end;
  finally
    FieldsEditor.Free;
  end;
end;
function TFieldsProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

procedure Register;
begin
  RegisterComponents('i-vcl Exports', [THTMLExport]);
  RegisterPropertyEditor(TypeInfo(TFieldslist), nil, '',TFieldsProperty);

end;

end.
