unit ShapeFormEd;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,igriegaclasses,igriegastrs, Buttons, ToolWin, ComCtrls, StdCtrls,funciones,
  ExtCtrls, Spin,pointwin,math,paramshform,aboutunit,proppol,ShXMLEdit;

CONST
   crPolOther=1;
   crPoints=2;
   crPointsSel=3;
   crPolOval=4;
   crPolRect=5;
   crPolRound=6;
   crPolReg=7;
type
  TfrmPrinShForm = class(TForm)
    SD1: TSaveDialog;
    Panel2: TPanel;
    btnPolOther: TSpeedButton;
    btnMoveHome: TSpeedButton;
    btnPointMove: TSpeedButton;
    btnSave: TSpeedButton;
    lblCoord: TLabel;
    btnPolOval: TSpeedButton;
    btnpolRect: TSpeedButton;
    btnLoad: TSpeedButton;
    OD1: TOpenDialog;
    btnPolRound: TSpeedButton;
    btnPluma: TSpeedButton;
    btnPolReg: TSpeedButton;
    btnAbout: TSpeedButton;
    SpinNPol: TSpinEdit;
    btnProperties: TSpeedButton;
    Label1: TLabel;
    lblNPol: TLabel;
    BitBtn1: TBitBtn;
    SpeedButton1: TSpeedButton;
    btnParameters: TSpeedButton;
    procedure btnPolOtherClick(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure btnSaveClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure btnMoveHomeClick(Sender: TObject);
    procedure btnPointMoveClick(Sender: TObject);
    procedure btnSalirClick(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnPolOvalClick(Sender: TObject);
    procedure btnpolRectClick(Sender: TObject);
    procedure btnLoadClick(Sender: TObject);
    procedure btnPolRoundClick(Sender: TObject);
    procedure btnPolRegClick(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
    procedure SpinNPolChange(Sender: TObject);
    procedure btnPropertiesClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure btnParametersClick(Sender: TObject);
  private
    { Private declarations }
  public
     Polygons:TCustomPolygons;
     Tipo:Char;
     A,B:TPoint;
     NPol:Integer;
     down:Boolean;
     DrawPoint:Boolean;
     pluma:boolean;
     PolOpen:Boolean;
  frmPointWin:tfrmPointWin;
  frmParam:TfrmParamshform;
  frmAbout:TfrmAbout;
  frmPropPol:TfrmPropPol;
  frmXMLEdit: TfrmXMLEdit;
    { Public declarations }
  end;

implementation

{$R *.dfm}
{$R shresource.res}
procedure TfrmPrinShForm.FormCreate(Sender: TObject);
begin
   frmPointWin:=tfrmPointWin.Create(self);
   frmParam:=TfrmParamshform.Create(self);
   frmAbout:=TfrmAbout.create(self);
   frmPropPol:=TfrmPropPol.create(self);
   frmXMLEdit:=TfrmXMLEdit.Create(self);
   self.FormStyle:=fsNormal;
   frmabout.Label1.Caption:=sMsgAboutShapeForm;
   A:=Point(-1,-1);
   B:=A;
   down:=False;
   PolOpen:=False;
//   Polygons:=TCustomPolygons.Create(self);
   Tipo:='L';
   NPol:=-1;
   self.WindowState:=wsMaximized;
   DrawPoint:=true;
   Pluma:=true;
   self.SD1.Title:=sMsgTitleShapeFormSave;
   frmparam.spinx.Value:=50;
   frmparam.spinY.Value:=50;
   frmPointWin.Left:=screen.Width-frmPointWin.Width-1;
   frmPointWin.Top:=1;
{   frmParam.Left:=screen.Width-frmParam.Width-1;
   frmParam.Top:=1;
   }
   // Load resources
   btnload.Glyph.LoadFromResourceName(hinstance,'OPEN');
   btnmovehome.Glyph.LoadFromResourceName(hinstance,'MOVEHOME');
   btnpluma.Glyph.LoadFromResourceName(hinstance,'BTNPENCIL');
   btnPointMove.Glyph.LoadFromResourceName(hinstance,'MOVEPOINT');
   btnPolOther.Glyph.LoadFromResourceName(hinstance,'POLOTHER');
   btnPolOval.Glyph.LoadFromResourceName(hinstance,'POLOVAL');
   btnPolRect.Glyph.LoadFromResourceName(hinstance,'POLRECT');
   btnPolRound.Glyph.LoadFromResourceName(hinstance,'POLROUND');
   btnSave.Glyph.LoadFromResourceName(hinstance,'SAVE');
   btnParameters.Glyph.LoadFromResourceName(hinstance,'PARAM');
//   btnSalir.Glyph.LoadFromResourceName(hinstance,'EXIT');
   btnPolreg.Glyph.LoadFromResourceName(hinstance,'POLREG');
   screen.Cursors[crPoints]:=LoadCursor(HInstance, 'CURPOINT');
   screen.Cursors[crPointsSel]:=LoadCursor(HInstance, 'CURPOINTSEL');
   screen.Cursors[crPolOval]:=LoadCursor(HInstance, 'CUROVAL');
   screen.Cursors[crPolRect]:=LoadCursor(HInstance, 'CURRECT');
   screen.Cursors[crPolRound]:=LoadCursor(HInstance, 'CURROUND');
   screen.Cursors[crPolOther]:=LoadCursor(HInstance, 'CUROTHER');
   screen.Cursors[crPolReg]:=LoadCursor(HInstance, 'CURREG');
end;

procedure TfrmPrinShForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i:integer;
    t:TPoint;
    radius:Real;
    tr,trt:TTreenode;
    L:Tstringlist;
begin
  if button=mbleft then
   if down then
   begin
      if pluma then
      begin
         pluma:=(btnPluma.Down) and (tipo='P');
         cross(canvas,point(x,y),5,clblue);
         if A.X<>-1 then
         begin
            Polygons[Polygons.count-1].Points.Add(A);
            Canvas.MoveTo(X,Y);
         end;
         A:=Point(X,Y);
         if Polygons[Polygons.count-1].Points.Count>0 then
            Canvas.LineTo(Polygons[Polygons.count-1].Points[Polygons[Polygons.count-1].Points.Count-1].Point.X,
                          Polygons[Polygons.count-1].Points[Polygons[Polygons.count-1].Points.Count-1].Point.Y);
      end;
   end
   else
      case tipo of
         'O':begin
               if (B.X=-1) and (B.Y=-1) then
               begin
                  npol:=Polygons.FindPoint(point(x,y),5);
                  if npol>-1 then
                  begin
                     cursor:=crPointsSel;
                     canvas.Pen.Color:=clred;
                     Polygons.DrawPolygon(canvas,npol,drawpoint);
                     canvas.Pen.Color:=clBlack;
                     B:=Polygons[npol].Points.foundPoint;
                     cross(Canvas,b);
                     SpinNPol.Value:=npol+1;
                  end;
               end
               else
               begin
                  cursor:=crPoints;
                  if  not(ssShift in Shift) then
                  with polygons[npol] do
                  case frmPointWin.rgPoint.ItemIndex of
                     0:begin
                         B:=Points.foundpoint;
                         Points.Add(center.getpoint);
                         Points.OffSet(x-B.x,y-b.y);
                         center:=Points[Points.Count-1].Point;
                         Points.Delete(Points.Count-1);
                       end;
                     1:begin
                          Points[Points.NumberFoundPoint].Point.X:=X;
                          Points[Points.NumberFoundPoint].Point.Y:=Y;
                       end;
                     2:begin
                          if (Points.Count<=3) and (poltype=ptOther)  then
                             Polygons.Delete(npol)
                          else
                             Points.Delete(Points.NumberFoundPoint)
                       end;
                     3:Polygons.Delete(npol);
                     4:Points.SubtractPoints(point(frmPointWin.SpinX.Value,frmPointWin.SpinY.Value));
                     5:Points.SetMaxPoints(frmPointWin.SpinMaxPoint.Value);
                     6:begin
                          center.SetPoint(x,y);
                          hascenter:=true;
                       end;
                     7:begin
                          center.SetPoint(points.GetCenterPoint);
                          hascenter:=true;
                       end;
                     8:begin
                          proppol.x:=X;
                          proppol.Y:=Y;
                          frmproppol.chkHasCenter.Checked:=hascenter;
                          frmproppol.txtName.Text:=name;
                          frmproppol.lblType.Caption:=poltypes[polygons[npol].poltype];
                          frmproppol.SpinCenterX.Value:=center.x;
                          frmproppol.SpinCentery.Value:=center.y;
                          frmproppol.SpinCornerX.Value:=Corners.X;
                          frmproppol.SpinCornerY.Value:=Corners.y;
                          frmproppol.tvPoints.Items.Clear;
                          proppol.np:=Points.Count;
                          for i:=0 to Points.Count-1 do
                          begin
                             if i<>Points.NumberFoundPoint then
                             begin
                                tr:=frmproppol.tvPoints.Items.Add(nil,'Point'+inttostr(i));
                                tr.ImageIndex:=3;
                                tr.SelectedIndex:=3;
                             end
                             else
                             begin
                                tr:=frmproppol.tvPoints.Items.Add(nil,'Point'+inttostr(i)+' (Marked)');
                                tr.ImageIndex:=0;
                                tr.SelectedIndex:=0;
                             end;
                             trt:=frmproppol.tvPoints.Items.AddChild(tr,inttostr(points[i].Point.X));
                             trt.ImageIndex:=1;
                             trt.SelectedIndex:=1;
                             trt:=frmproppol.tvPoints.Items.AddChild(tr,inttostr(points[i].Point.Y));
                             trt.ImageIndex:=2;
                             trt.SelectedIndex:=2;
                          end;
                          if frmproppol.ShowModal=mrOk then
                          begin
                             Points.Clear;
                             for i:=0 to (frmproppol.tvPoints.Items.Count div 3)-1 do
                             begin
                                points.Add(point(strtoint(frmproppol.tvpoints.Items[(i*3)+1].Text),strtoint(frmproppol.tvpoints.Items[(i*3)+2].Text)));
                             end;
                             Name:=frmproppol.txtName.Text;
                             hascenter:=frmproppol.chkHasCenter.Checked;
                             center.SetPoint(frmproppol.SpinCenterX.Value,frmproppol.SpinCenterY.Value);
                             corners.SetPoint(frmproppol.SpinCornerX.Value,frmproppol.SpinCornerY.Value);
                          end;
                       end;
                     9:begin
                         L:=TStringList.Create;
                         try
                            GetXMLDef(L);
                            polygons.AddFromStringList(L);
                            npol:=polygons.Count-1;
                            with polygons[npol] do
                            begin
                               B:=Points.foundpoint;
                               Points.Add(center.getpoint);
                               Points.OffSet(x-B.x,y-b.y);
                               center:=Points[Points.Count-1].Point;
                               Points.Delete(Points.Count-1);
                            end;
                         finally
                            l.Free
                         end;
                       end;
                     10:begin
                          if hasCenter and (frmPointWin.rgTurn.ItemIndex=0) then
                             Turn(Center.GetPoint,frmPointWin.spindegrees.value)
                          else
                             Turn(Points.FoundPoint,frmPointWin.spindegrees.value);
                       end;
                    11:Begin
                          Points.Add(center.getpoint);
                          if hascenter and (frmPointWin.rgTurn.ItemIndex=0) then
                             points.Mirror(center.getpoint)
                          else
                             points.Mirror(Points.foundpoint);
                          center:=Points[Points.Count-1].Point;
                          Points.Delete(Points.Count-1);
                       end;
                    12:Begin
                          Points.Add(center.getpoint);
                          if hascenter and (frmPointWin.rgTurn.ItemIndex=0) then
                             points.Flip(center.getpoint)
                          else
                             points.Flip(Points.foundpoint);
                          center:=Points[Points.Count-1].Point;
                          Points.Delete(Points.Count-1);
                       end;
                    13:Begin
                          Points.Add(center.getpoint);
                          if hascenter and (frmPointWin.rgTurn.ItemIndex=0) then
                             points.Pivot(Center.GetPoint)
                          else
                             points.Pivot(Points.foundpoint);
                          center:=Points[Points.Count-1].Point;
                          Points.Delete(Points.Count-1);
                       end;
                  end;
                  B:=point(-1,-1);
                  PolOpen:=false;
                  repaint;
//                  frmPointWin.Show;
               end
            end;
         'V':with Polygons[Polygons.count-1] do
             begin
                Points.Add(A);
                Points.Add(Point(X,Y));
                PolType:=ptOval;
                Center.setpoint(min(a.X,x)+((max(a.X,x)-min(a.X,x)) div 2),min(a.y,y)+((max(a.y,y)-min(a.y,y)) div 2));
                HasCenter:=true;
                btnpolOval.Down:=false;
                tipo:='L';
                cursor:=crdefault;
                PolOpen:=false;
                repaint;
             end;
         'R':with Polygons[Polygons.count-1] do
             begin
                Points.Add(A);
                Points.Add(Point(X,Y));
                PolType:=ptRect;
                Center.setpoint(min(a.X,x)+((max(a.X,x)-min(a.X,x)) div 2),min(a.y,y)+((max(a.y,y)-min(a.y,y)) div 2));
                HasCenter:=true;
                btnpolRect.Down:=false;
                tipo:='L';
                cursor:=crdefault;
                PolOpen:=false;
                repaint;
             end;
         'D':with Polygons[Polygons.count-1] do
             begin
                Points.Add(A);
                Points.Add(Point(X,Y));
                corners.setpoint(frmparam.spinx.Value,frmparam.spiny.Value);
                PolType:=ptRoundRect;
                Center.setpoint(min(a.X,x)+((max(a.X,x)-min(a.X,x)) div 2),min(a.y,y)+((max(a.y,y)-min(a.y,y)) div 2));
                HasCenter:=true;
                btnpolRound.Down:=false;
                tipo:='L';
//                frmparam.Hide;
                cursor:=crdefault;
                PolOpen:=false;
                repaint;
             end;
         'H':with Polygons[Polygons.count-1] do
             begin
                radius:=sqrt(power(x-a.x,2)+Power(y-a.y,2));
                Center.setpoint(A);
                HasCenter:=true;
                for i:=0 to frmparam.spinsides.Value-1 do
                begin
                   t.X:=A.X+ROUND(radius*cos(degtorad(((360 div frmparam.spinsides.Value)*i)+self.frmPointWin.SpinDegrees.Value)));
                   t.Y:=A.Y+ROUND(radius*sin(degtorad(((360 div frmparam.spinsides.Value)*i)+self.frmPointWin.SpinDegrees.Value)));
                   Points.Add(t);
                end;
                PolType:=ptOther;
                btnpolReg.Down:=false;
                tipo:='L';
                cursor:=crdefault;
//                frmparam.Hide;
                PolOpen:=false;
                repaint;
             end;
      end;
   if self.btnPointMove.Down then
      self.frmPointWin.Show;
end;


procedure TfrmPrinShForm.FormDestroy(Sender: TObject);
begin
   frmPointWin.free;
   frmParam.free;
   frmAbout.Free;
   frmproppol.Free;
   frmXMLEdit.Free;
end;

procedure TfrmPrinShForm.FormDblClick(Sender: TObject);
begin
   if PolOpen then
   with Polygons[Polygons.count-1] do
   begin
      btnpolother.Down:=False;
      Points.Add(A);
      Canvas.MoveTo(A.X,A.Y);
      PolOpen:=False;
      tipo:='L';
      down:=false;
      center.SetPoint(points.GetCenterPoint);
      hascenter:=true;
      repaint;
   end;
   Cursor:=crDefault;
end;

procedure TfrmPrinShForm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   lblCoord.Caption:='('+inttostr(X)+','+inttostr(Y)+')';
   if PolOpen and (ssLeft in Shift) and pluma then
   begin
      if A.X<>-1 then
      begin
         Polygons[Polygons.count-1].Points.Add(A);
         Canvas.MoveTo(X,Y);
      end;
      A:=Point(X,Y);
      if Polygons[Polygons.count-1].Points.Count>0 then
         Canvas.LineTo(Polygons[Polygons.count-1].Points[Polygons[Polygons.count-1].Points.Count-1].Point.X,
                          Polygons[Polygons.count-1].Points[Polygons[Polygons.count-1].Points.Count-1].Point.Y);
      cross(canvas,point(x,y),5,clblue);
   end;

end;

procedure TfrmPrinShForm.btnSaveClick(Sender: TObject);
begin
   if SD1.Execute then
   begin
      Polygons.SaveToFile(SD1.FileName);
   end;
end;


procedure TfrmPrinShForm.FormPaint(Sender: TObject);
begin
   lblnpol.Caption:='of '+inttostr(polygons.Count);
   canvas.Brush.Style:=bsclear;
   polygons.Draw(Canvas,DrawPoint);
end;

procedure TfrmPrinShForm.btnMoveHomeClick(Sender: TObject);
begin
   Polygons.MoveToOrigin;
   repaint;
end;

procedure TfrmPrinShForm.btnPolOtherClick(Sender: TObject);
begin
   if not PolOpen then
   begin
      PolOpen:=True;
      down:=true;
      Polygons.Add;
      A:=Point(-1,-1);
      B:=Point(-1,-1);
      NPol:=-1;
      Tipo:='P';
      Cursor:=crPolOther;
   end
      else
      begin
         btnPolOval.Down:=false;
         case tipo of
            'P':btnPolOther.Down:=true;
            'V':btnPolOval.Down:=true;
            'R':btnPolRect.Down:=true;
            'D':btnPolRound.Down:=true;
            'H':btnPolReg.Down:=true;
         end
      end;
{   else
      Self.FormDblClick(sender);}
   frmPointWin.Hide;
end;

procedure TfrmPrinShForm.btnPointMoveClick(Sender: TObject);
begin
   if Tipo='O' then
   begin
      Tipo:='L';
      Cursor:=crDefault;
      frmPointWin.Hide;
   end
   else
   begin
      Tipo:='O';
      Cursor:=crPoints;
      frmPointWin.Show;
   end;
end;

procedure TfrmPrinShForm.btnPolOvalClick(Sender: TObject);
begin
   if not PolOpen then
   begin
      PolOpen:=True;
      down:=true;
      Polygons.Add;
      A:=Point(-1,-1);
      B:=Point(-1,-1);
      NPol:=-1;
      Tipo:='V';
      Cursor:=crPolOval;
   end
   else
      begin
         btnPolOval.Down:=false;
         case tipo of
            'P':btnPolOther.Down:=true;
            'V':btnPolOval.Down:=true;
            'R':btnPolRect.Down:=true;
            'D':btnPolRound.Down:=true;
            'H':btnPolReg.Down:=true;
         end
      end;
   frmPointWin.Hide;
end;

procedure TfrmPrinShForm.btnpolRectClick(Sender: TObject);
begin
   if not PolOpen then
   begin
      PolOpen:=True;
      down:=true;
      Polygons.Add;
      A:=Point(-1,-1);
      B:=Point(-1,-1);
      NPol:=-1;
      Tipo:='R';
      Cursor:=crPolRect;
   end
   else
      begin
         btnPolOval.Down:=false;
         case tipo of
            'P':btnPolOther.Down:=true;
            'V':btnPolOval.Down:=true;
            'R':btnPolRect.Down:=true;
            'D':btnPolRound.Down:=true;
            'H':btnPolReg.Down:=true;
         end
      end;
   frmPointWin.Hide;
end;

procedure TfrmPrinShForm.btnSalirClick(Sender: TObject);
begin
   close;
end;

procedure TfrmPrinShForm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if button=mbleft then
   begin
      pluma:=true;
      if (tipo='V') or (tipo='R') or (tipo='D') or (tipo='H') then down:=false;
   end;   
end;


procedure TfrmPrinShForm.btnLoadClick(Sender: TObject);
begin
   if od1.Execute then
      self.Polygons.LoadFromFile(od1.FileName);
   repaint;
end;

procedure TfrmPrinShForm.btnPolRoundClick(Sender: TObject);
begin
   if not PolOpen then
   begin
      PolOpen:=True;
      down:=true;
      Polygons.Add;
      A:=Point(-1,-1);
      B:=Point(-1,-1);
      NPol:=-1;
      Tipo:='D';
//      frmparam.Show;
      Cursor:=crPolRound;
   end
   else
      begin
//         frmparam.Hide;      
         btnPolOval.Down:=false;
         case tipo of
            'P':btnPolOther.Down:=true;
            'V':btnPolOval.Down:=true;
            'R':btnPolRect.Down:=true;
            'D':btnPolRound.Down:=true;
            'H':btnPolReg.Down:=true;
         end
      end;
   frmPointWin.Hide;
end;


procedure TfrmPrinShForm.btnPolRegClick(Sender: TObject);
begin
   if not PolOpen then
   begin
      PolOpen:=True;
      down:=true;
      Polygons.Add;
      A:=Point(-1,-1);
      B:=Point(-1,-1);
      NPol:=-1;
      Tipo:='H';
//      frmparam.Show;
      Cursor:=crPolReg;
   end
   else
      begin
//         frmparam.Hide;
         btnPolReg.Down:=false;
         case tipo of
            'P':btnPolOther.Down:=true;
            'V':btnPolOval.Down:=true;
            'R':btnPolRect.Down:=true;
            'D':btnPolRound.Down:=true;
            'H':btnPolReg.Down:=true;
         end
      end;
   frmPointWin.Hide;
end;

function DupeString(const AText: string; ACount: Integer): string;
   var
     P: PChar;
     C: Integer;
   begin
     C := Length(AText);
     SetLength(Result, C * ACount);
     P := Pointer(Result);
     if P = nil then Exit;
     while ACount > 0 do
     begin
       Move(Pointer(AText)^, P^, C);
       Inc(P, C);
       Dec(ACount);
     end;
end;


procedure TfrmPrinShForm.btnAboutClick(Sender: TObject);
begin
   frmabout.ShowModal;
end;

procedure TfrmPrinShForm.SpinNPolChange(Sender: TObject);
begin
   if between(spinNPol.Value,0,Polygons.Count) then
   begin
      if (self.Polygons.Count=0) and (spinNPol.Value<>0) then
         spinNPol.Value:=0;
   end
   else
      if spinNPol.Value<>0 then
         spinNPol.Value:=0;
end;

procedure TfrmPrinShForm.btnPropertiesClick(Sender: TObject);
var i:integer;
    tr,trt:TTreenode;
begin
  if SpinNPol.value>0 then
  with polygons[SpinNPol.value-1] do
  begin
    frmproppol.txtName.Text:=name;
    frmproppol.chkHasCenter.checked:=hascenter;
    frmproppol.lblType.Caption:=poltypes[polygons[SpinNPol.value-1].poltype];
    frmproppol.SpinCenterX.Value:=center.x;
    frmproppol.SpinCentery.Value:=center.y;
    frmproppol.SpinCornerX.Value:=Corners.X;
    frmproppol.SpinCornerY.Value:=Corners.y;
    frmproppol.tvPoints.Items.Clear;
    proppol.np:=Points.Count;
    for i:=0 to Points.Count-1 do
    begin
       tr:=frmproppol.tvPoints.Items.Add(nil,'Point'+inttostr(i));
       tr.ImageIndex:=3;
       tr.SelectedIndex:=3;
       trt:=frmproppol.tvPoints.Items.AddChild(tr,inttostr(points[i].Point.X));
       trt.ImageIndex:=1;
       trt.SelectedIndex:=1;
       trt:=frmproppol.tvPoints.Items.AddChild(tr,inttostr(points[i].Point.Y));
       trt.ImageIndex:=2;
       trt.SelectedIndex:=2;
    end;
    if frmproppol.ShowModal=mrOk then
    begin
       Points.Clear;
       for i:=0 to (frmproppol.tvPoints.Items.Count div 3)-1 do
           points.Add(point(strtoint(frmproppol.tvpoints.Items[(i*3)+1].Text),strtoint(frmproppol.tvpoints.Items[(i*3)+2].Text)));
       Name:=frmproppol.txtName.Text;
       hascenter:=frmproppol.chkHasCenter.Checked;
       center.SetPoint(frmproppol.SpinCenterX.Value,frmproppol.SpinCenterY.Value);
       Corners.SetPoint(frmproppol.SpinCornerX.Value,frmproppol.SpinCornerY.Value);
    end;
    repaint;
  end;
end;

procedure TfrmPrinShForm.BitBtn1Click(Sender: TObject);
begin
   self.ModalResult:=mrOk;
   close;
end;

procedure TfrmPrinShForm.BitBtn2Click(Sender: TObject);
begin
   self.ModalResult:=mrCancel;
   close;
end;

procedure TfrmPrinShForm.SpeedButton1Click(Sender: TObject);
begin
   frmXMLEdit.txtXmlDef.Lines.Clear;
   POLYGONS.GetXMLDef(TStringList(frmXMLEdit.txtXmlDef.Lines));
   if frmXMLEdit.ShowModal=mrok then
   begin
      polygons.Clear;
      Polygons.AddFromStringList(TStringList(frmXMLEdit.txtXmlDef.Lines));
      repaint;
   end;
end;

procedure TfrmPrinShForm.btnParametersClick(Sender: TObject);
begin
   frmparam.cbLoadType.ItemIndex:=ord(polygons.LoadType);
   frmParam.ShowModal;
   polygons.LoadType:=TLoadType(frmparam.cbLoadType.ItemIndex);
end;

end.

