unit charmap;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids, Buttons,printers;

type
  TfrmCharMap = class(TForm)
    cbFonts: TComboBox;
    pnlChar: TPanel;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Panel1: TPanel;
    grChar: TStringGrid;
    rbPantalla: TRadioButton;
    rbImpresora: TRadioButton;

    procedure FormCreate(Sender: TObject);
    procedure grCharClick(Sender: TObject);
    procedure cbFontsChange(Sender: TObject);
    procedure rbPantallaClick(Sender: TObject);
    procedure rbImpresoraClick(Sender: TObject);
  private
    { Private declarations }
  public
//    defaultFont:string;    { Public declarations }
  end;

var
  frmCharMap: TfrmCharMap;

implementation

{$R *.dfm}

procedure TfrmCharMap.FormCreate(Sender: TObject);
var
   i,j,k:integer;
begin
   k:=0;
   for j:=0 to 7 do
      for i:=0 to 32 do
      begin
         grchar.Cells[i,j]:=chr(k);
         k:=k+1;
      end;
   cbfonts.Items:=screen.Fonts;
   cbfonts.ItemIndex:=0;
   Pnlchar.Font.Name:=cbfonts.Items[cbfonts.ItemIndex];
   grchar.Font.Name:=cbfonts.Items[cbfonts.ItemIndex];
end;

procedure TfrmCharMap.grCharClick(Sender: TObject);
begin
   pnlchar.Caption:=grchar.Cells[grchar.col,grchar.row];
end;

procedure TfrmCharMap.cbFontsChange(Sender: TObject);
begin
   Pnlchar.Font.Name:=cbfonts.Items[cbfonts.ItemIndex];
   grchar.Font.Name:=cbfonts.Items[cbfonts.ItemIndex];
end;

procedure TfrmCharMap.rbPantallaClick(Sender: TObject);
var
  fontname:TFontName;
begin
   fontname:=cbfonts.Items[cbfonts.itemindex];
   if rbpantalla.Checked then
   begin
      cbfonts.Clear;
      cbfonts.Items:=screen.Fonts;
      if cbfonts.Items.IndexOf(fontname)<>-1 then
         cbfonts.itemindex:=cbfonts.Items.IndexOf(fontname)
      else
         cbfonts.itemindex:=0;
      Pnlchar.Font.Name:=cbfonts.Items[cbfonts.ItemIndex];
      grchar.Font.Name:=cbfonts.Items[cbfonts.ItemIndex];
   end;
end;

procedure TfrmCharMap.rbImpresoraClick(Sender: TObject);
var
  fontname:TFontName;
begin
   fontname:=cbfonts.Items[cbfonts.itemindex];
   if rbimpresora.Checked then
   begin
      cbfonts.Clear;
      cbfonts.Items:=printer.Fonts;
      if cbfonts.Items.IndexOf(fontname)<>-1 then
         cbfonts.itemindex:=cbfonts.Items.IndexOf(fontname)
      else
         cbfonts.itemindex:=0;
      Pnlchar.Font.Name:=cbfonts.Items[cbfonts.ItemIndex];
      grchar.Font.Name:=cbfonts.Items[cbfonts.ItemIndex];
   end;

end;

end.
